<?php
/*
XTOC version 1.0 beta5
This is a modified version of the toc()function of Peter Harteg's CMSimple (www.cmsimple.dk). It has been modified by Till from NMuD (www.nmud.de). 
It is called via the template.htm file. You call it by adding at the top of the template.htm file:
 - <?php include ($pth['folder']['template'].'xtoc.php'); ? > (remove the space between ? and >) - 
The xtoc.php file is placed in the folder where the template resides. In the template you do not use "toc()" but "xtoc()" as menu function.
While the xtoc()-function (see below) of this file always has to be active, only one of the li()-functions must be active. The other ones have to be outcommented or removed. The li()-functions offer the following:
(1) normal menu function, just for control. (default in this distribution)
(2) adds H1-, H2-, and H3-headings as second but individual CSS classes. They offer individual handles for individual menu button styling. Now every button can have a different look.
(3) turns a clicked button to a clickable button. Originally, a clicked button cannot be clicked again.
(4) adds categories or spaces to a menu. Typing in "category_" or "break_" and formating it as an H1-heading adds a space to a menu. Typing in "category_New Category" and formating it as an H1-heading adds the category "New Category" to the menu. "New Category" is not linked, it cannot be clicked. Spaces and Categories can be formated via CSS, since they have the CSS class "category". Using "break_" adds a CSS class "break" instead of "category". To remove spaces and categories, you first have to exchange your template with a template, that does not provide the xtoc funtionality (i.e. the "default" template). This turns the spaces and categories to real headings which now can be removed. Later you switch back to your original template.
(5) combines functions (3) and (4)
(6) alternative searchbox() function. Does not write the word "Search" on the click button. Important for CSS layout changes of the search button.
(7) xlocator:
(8) xnewsbox:
*/
// normal toc() function, has always to be active, if one of the li() functions is being used ////////////////////
function xtoc($start,$end){global $hc,$hl,$s,$l;$ts_ta=array();if(isset($start)&&!isset($end))$end=$start;if(!isset($end))$end=3;if(!isset($start))$start=1;for($ts_i=0;$ts_i<$hl;$ts_i++){if($l[$hc[$ts_i]]==1){if($start==1)$ts_ta[]=$hc[$ts_i];$ts_r1=$ts_r2=$ts_i;}if($s==$hc[$ts_i]){$ts_s3=true;for($ts_j=$ts_r1+1;$ts_j<$hl;$ts_j++){if($l[$hc[$ts_j]]==1)break;if($l[$hc[$ts_j]]==2){if($start<3&&$end>1)$ts_ta[]=$hc[$ts_j];$ts_r2=$ts_j;$ts_s3=false;}if($s==$hc[$ts_j]){for($k=$ts_r2+1;$k<$hl;$k++){if($l[$hc[$k]]==3){if($end>2)$ts_ta[]=$hc[$k];}else{$ts_s3=false;break;}}}if($l[$hc[$ts_j]]==3&&$l[$s]==1&&$ts_s3)if($end>2)$ts_ta[]=$hc[$ts_j];}}}return xli($ts_ta,$start);}

// ( 1 ) normal li() function /////////////////////

// function xli($ts_ta,$ts_st){global $s,$c,$l,$h,$hc,$hl;if(count($ts_ta)==0)return;$ts_t='';if($ts_st=='submenu'||$ts_st=='search')$ts_t.='<ul class="'.$ts_st.'">';$b=0;if($ts_st==1||$ts_st==2||$ts_st==3){$b=$ts_st-1;$ts_st='menulevel';}$ts_j=0;$le=0;$lf[0]=$lf[1]=$lf[2]=$lf[3]=false;for($ts_i=0;$ts_i<$hl;$ts_i++){if(!isset($ts_ta[$ts_j]))break;if($hc[$ts_i]!=$ts_ta[$ts_j])continue;$ts_tf=($s!=$ts_ta[$ts_j]);if($ts_st=='menulevel'||$ts_st=='sitemaplevel'){for($k=(isset($ts_ta[$ts_j-1])?$l[$ts_ta[$ts_j-1]]:$b);$k<$l[$ts_ta[$ts_j]];$k++)$ts_t.='<ul class="'.$ts_st.($k+1).'">';}$ts_t.='<li class="';if(!$ts_tf)$ts_t.='s';$ts_t.='doc';if(isset($hc[$ts_i+1]))if($l[$hc[$ts_i+1]]>$l[$ts_ta[$ts_j]])$ts_t.='s';$ts_t.='">';if($ts_tf)$ts_t.=a($ts_ta[$ts_j],'');$ts_t.=$h[$ts_ta[$ts_j]];if($ts_tf)$ts_t.='</a>';if($ts_st=='menulevel'||$ts_st=='sitemaplevel'){if((isset($ts_ta[$ts_j+1])?$l[$ts_ta[$ts_j+1]]:$b)>$l[$ts_ta[$ts_j]])$lf[$l[$ts_ta[$ts_j]]]=true;else{$ts_t.='</li>';$lf[$l[$ts_ta[$ts_j]]]=false;}for($k=$l[$ts_ta[$ts_j]];$k>(isset($ts_ta[$ts_j+1])?$l[$ts_ta[$ts_j+1]]:$b);$k--){$ts_t.='</ul>';if($lf[$k-1]){$ts_t.='</li>';$lf[$k-1]=false;}};}else $ts_t.='</li>';$ts_j++;}if($ts_st=='submenu'||$ts_st=='search')$ts_t.='</ul>';return $ts_t;}
//__________________________________________________________________________
//
// ( 2 ) li() function adds individual page headings as additional CSS classes to every menu button ///////////////////////

// function xli($ts_ta,$ts_st){global $s,$c,$l,$h,$hc,$hl,$u;if(count($ts_ta)==0)return;$ts_t='';if($ts_st=='submenu'||$ts_st=='search')$ts_t.='<ul class="'.$ts_st.'">';$b=0;if($ts_st==1||$ts_st==2||$ts_st==3){$b=$ts_st-1;$ts_st='menulevel';}$ts_j=0;$le=0;$lf[0]=$lf[1]=$lf[2]=$lf[3]=false;for($ts_i=0;$ts_i<$hl;$ts_i++){if(!isset($ts_ta[$ts_j]))break;if($hc[$ts_i]!=$ts_ta[$ts_j])continue;$ts_tf=($s!=$ts_ta[$ts_j]);if($ts_st=='menulevel'||$ts_st=='sitemaplevel'){for($k=(isset($ts_ta[$ts_j-1])?$l[$ts_ta[$ts_j-1]]:$b);$k<$l[$ts_ta[$ts_j]];$k++)$ts_t.='<ul class="'.$ts_st.($k+1).'">';}$ts_t.='<li class="';if (strrchr($u[$ts_i],':')) {$ts_t.=substr(strrchr($u[$ts_i],':'),1);} else $ts_t.=$u[$ts_i]; $ts_t.=' '; if(!$ts_tf)$ts_t.='s';$ts_t.='doc';if(isset($hc[$ts_i+1]))if($l[$hc[$ts_i+1]]>$l[$ts_ta[$ts_j]])$ts_t.='s';$ts_t.='">';if($ts_tf)$ts_t.=a($ts_ta[$ts_j],'');$ts_t.=$h[$ts_ta[$ts_j]];if($ts_tf)$ts_t.='</a>';if($ts_st=='menulevel'||$ts_st=='sitemaplevel'){if((isset($ts_ta[$ts_j+1])?$l[$ts_ta[$ts_j+1]]:$b)>$l[$ts_ta[$ts_j]])$lf[$l[$ts_ta[$ts_j]]]=true;else{$ts_t.='</li>';$lf[$l[$ts_ta[$ts_j]]]=false;}for($k=$l[$ts_ta[$ts_j]];$k>(isset($ts_ta[$ts_j+1])?$l[$ts_ta[$ts_j+1]]:$b);$k--){$ts_t.='</ul>';if($lf[$k-1]){$ts_t.='</li>';$lf[$k-1]=false;}};}else $ts_t.='</li>';$ts_j++;}if($ts_st=='submenu'||$ts_st=='search')$ts_t.='</ul>';return $ts_t;}
//__________________________________________________________________________
//
// ( 3 ) clicked button remains clickable ////////////////////

// function xli($ts_ta,$ts_st){global $s,$c,$l,$h,$hc,$hl;if(count($ts_ta)==0)return;$ts_t='';if($ts_st=='submenu'||$ts_st=='search')$ts_t.='<ul class="'.$ts_st.'">';$b=0;if($ts_st==1||$ts_st==2||$ts_st==3){$b=$ts_st-1;$ts_st='menulevel';}$ts_j=0;$le=0;$lf[0]=$lf[1]=$lf[2]=$lf[3]=false;for($ts_i=0;$ts_i<$hl;$ts_i++){if(!isset($ts_ta[$ts_j]))break;if($hc[$ts_i]!=$ts_ta[$ts_j])continue;$ts_tf=($s!=$ts_ta[$ts_j]);if($ts_st=='menulevel'||$ts_st=='sitemaplevel'){for($k=(isset($ts_ta[$ts_j-1])?$l[$ts_ta[$ts_j-1]]:$b);$k<$l[$ts_ta[$ts_j]];$k++)$ts_t.='<ul class="'.$ts_st.($k+1).'">';}$ts_t.='<li class="';if(!$ts_tf)$ts_t.='s';$ts_t.='doc';if(isset($hc[$ts_i+1]))if($l[$hc[$ts_i+1]]>$l[$ts_ta[$ts_j]])$ts_t.='s';$ts_t.='">';/*if($ts_tf)*/$ts_t.=a($ts_ta[$ts_j],'');$ts_t.=$h[$ts_ta[$ts_j]];/*if($ts_tf)*/$ts_t.='</a>';if($ts_st=='menulevel'||$ts_st=='sitemaplevel'){if((isset($ts_ta[$ts_j+1])?$l[$ts_ta[$ts_j+1]]:$b)>$l[$ts_ta[$ts_j]])$lf[$l[$ts_ta[$ts_j]]]=true;else{$ts_t.='</li>';$lf[$l[$ts_ta[$ts_j]]]=false;}for($k=$l[$ts_ta[$ts_j]];$k>(isset($ts_ta[$ts_j+1])?$l[$ts_ta[$ts_j+1]]:$b);$k--){$ts_t.='</ul>';if($lf[$k-1]){$ts_t.='</li>';$lf[$k-1]=false;}};}else $ts_t.='</li>';$ts_j++;}if($ts_st=='submenu'||$ts_st=='search')$ts_t.='</ul>';return $ts_t;}
//__________________________________________________________________________
//
// ( 4 ) addition of "break_" or "category_" in front of an H1 heading results in an unlinked space or unlinked heading (category) for spacing in menu ///

if ($f == 'sitemap'){$title = $tx['title'][$f];$o = '<h1>' . $title . '</h1>';$o .= xli($hc, 'sitemaplevel');}function xli($ts_ta, $ts_st){global $s, $c, $l, $h, $hc, $hl;if (count($ts_ta) == 0)return;$ts_t = '';if ($ts_st == 'submenu' || $ts_st == 'search')$ts_t .= '<ul class="' . $ts_st . '">';$b = 0;if ($ts_st == 1 || $ts_st == 2 || $ts_st == 3){$b = $ts_st-1;$ts_st = 'menulevel';}$ts_j = 0;$le = 0;$lf[0] = $lf[1] = $lf[2] = $lf[3] = false;for($ts_i = 0;$ts_i < $hl;$ts_i++){if (!isset($ts_ta[$ts_j]))break;if($hc[$ts_i]!=$ts_ta[$ts_j])continue;$ts_tf = ($s != $ts_ta[$ts_j]);if ($ts_st == 'menulevel' || $ts_st == 'sitemaplevel'){for($k = (isset($ts_ta[$ts_j-1])?$l[$ts_ta[$ts_j-1]]:$b);$k < $l[$ts_ta[$ts_j]];$k++)$ts_t .= '<ul class="' . $ts_st . ($k + 1) . '">';}if (eregi('category_', $h[$ts_ta[$ts_j]])){$ts_t .= '<li class="category">';}elseif (eregi('break_', $h[$ts_ta[$ts_j]])){$ts_t .= '<li class="break">';}else{$ts_t .= '<li class="';if (!$ts_tf)$ts_t .= 's';$ts_t .= 'doc';if (isset($hc[$ts_i + 1]))if ($l[$hc[$ts_i + 1]] > $l[$ts_ta[$ts_j]])$ts_t .= 's';$ts_t .= '">';}if (eregi('break_', $h[$ts_ta[$ts_j]])){if(eregi_replace('break_', '', $h[$ts_ta[$ts_j]]) || eregi_replace('break_', '', $h[$ts_ta[$ts_j]])== ''){$ts_t .= '&nbsp;';}}elseif (eregi('category_', $h[$ts_ta[$ts_j]])){if(ereg_replace('_', ' ', eregi_replace('category_', '', $h[$ts_ta[$ts_j]])) == ''){$ts_t .= '&nbsp;';}else{$ts_t .= ereg_replace('_', ' ', eregi_replace('category_', '', $h[$ts_ta[$ts_j]]));}}else{if($ts_tf)$ts_t .= a($ts_ta[$ts_j], '');$ts_t .= $h[$ts_ta[$ts_j]];if($ts_tf)$ts_t .= '</a>';}if($ts_st == 'menulevel' || $ts_st == 'sitemaplevel'){if((isset($ts_ta[$ts_j + 1])?$l[$ts_ta[$ts_j + 1]]:$b) > $l[$ts_ta[$ts_j]])$lf[$l[$ts_ta[$ts_j]]] = true;else{$ts_t .= '</li>';$lf[$l[$ts_ta[$ts_j]]]=false;}for($k=$l[$ts_ta[$ts_j]];$k > (isset($ts_ta[$ts_j + 1])?$l[$ts_ta[$ts_j + 1]]:$b);$k--){$ts_t .= '</ul>';if($lf[$k-1]){$ts_t .= '</li>';$lf[$k-1] = false;}};} else $ts_t .= '</li>';$ts_j++;}if ($ts_st == 'submenu' || $ts_st == 'search')$ts_t .= '</ul>';return $ts_t;}
//__________________________________________________________________________
//
// ( 5 ) combines function 3 with function 4 ///

// if ($f == 'sitemap'){$title = $tx['title'][$f];$o = '<h1>' . $title . '</h1>';$o .= xli($hc, 'sitemaplevel');}function xli($ts_ta, $ts_st){global $s, $c, $l, $h, $hc, $hl;if (count($ts_ta) == 0)return;$ts_t = '';if ($ts_st == 'submenu' || $ts_st == 'search')$ts_t .= '<ul class="' . $ts_st . '">';$b = 0;if ($ts_st == 1 || $ts_st == 2 || $ts_st == 3){$b = $ts_st-1;$ts_st = 'menulevel';}$ts_j = 0;$le = 0;$lf[0] = $lf[1] = $lf[2] = $lf[3] = false;for($ts_i = 0;$ts_i < $hl;$ts_i++){if (!isset($ts_ta[$ts_j]))break;if($hc[$ts_i]!=$ts_ta[$ts_j])continue;$ts_tf = ($s != $ts_ta[$ts_j]);if ($ts_st == 'menulevel' || $ts_st == 'sitemaplevel'){for($k = (isset($ts_ta[$ts_j-1])?$l[$ts_ta[$ts_j-1]]:$b);$k < $l[$ts_ta[$ts_j]];$k++)$ts_t .= '<ul class="' . $ts_st . ($k + 1) . '">';}if (eregi('category_', $h[$ts_ta[$ts_j]])){$ts_t .= '<li class="category">';}elseif (eregi('break_', $h[$ts_ta[$ts_j]])){$ts_t .= '<li class="break">';}else{$ts_t .= '<li class="';if (!$ts_tf)$ts_t .= 's';$ts_t .= 'doc';if (isset($hc[$ts_i + 1]))if ($l[$hc[$ts_i + 1]] > $l[$ts_ta[$ts_j]])$ts_t .= 's';$ts_t .= '">';}if (eregi('break_', $h[$ts_ta[$ts_j]])){if(eregi_replace('break_', '', $h[$ts_ta[$ts_j]]) || eregi_replace('break_', '', $h[$ts_ta[$ts_j]])== ''){$ts_t .= '&nbsp;';}}elseif (eregi('category_', $h[$ts_ta[$ts_j]])){if(ereg_replace('_', ' ', eregi_replace('category_', '', $h[$ts_ta[$ts_j]])) == ''){$ts_t .= '&nbsp;';}else{$ts_t .= ereg_replace('_', ' ', eregi_replace('category_', '', $h[$ts_ta[$ts_j]]));}}else{/*if($ts_tf)*/$ts_t .= a($ts_ta[$ts_j], '');$ts_t .= $h[$ts_ta[$ts_j]];/*if($ts_tf)*/$ts_t .= '</a>';}if($ts_st == 'menulevel' || $ts_st == 'sitemaplevel'){if((isset($ts_ta[$ts_j + 1])?$l[$ts_ta[$ts_j + 1]]:$b) > $l[$ts_ta[$ts_j]])$lf[$l[$ts_ta[$ts_j]]] = true;else{$ts_t .= '</li>';$lf[$l[$ts_ta[$ts_j]]]=false;}for($k=$l[$ts_ta[$ts_j]];$k > (isset($ts_ta[$ts_j + 1])?$l[$ts_ta[$ts_j + 1]]:$b);$k--){$ts_t .= '</ul>';if($lf[$k-1]){$ts_t .= '</li>';$lf[$k-1] = false;}};} else $ts_t .= '</li>';$ts_j++;}if ($ts_st == 'submenu' || $ts_st == 'search')$ts_t .= '</ul>';return $ts_t;}
//__________________________________________________________________________
//
// ( 6 ) removes "Search" Text from search button ///

//function xsearchbox(){global $sn,$tx;return '<form action="'.$sn.'" method="post">'.tag('input type="text" class="text" name="search" size="12"').tag('input type="hidden" name="function" value="search"').' '.tag('input type="submit" class="submit" value=""').'</form>';}
//__________________________________________________________________________
//
// ( 7 ) xlocator: is required for polishing the "Home" page in the breadcrumb navigation, if "category_" is used for the first menu point. Can be used in combination with function (4) or (5).///

function xlocator(){global $title,$h,$s,$f,$c,$l,$hc;if(preg_match("/\#CMSimple hide\#/is",$c[$s]))return $h[$s];if($title!=''&&$h[$s]!=$title)return $title;$t='';$tl=$l[$s];if($tl>1){for($i=$s-1; $i>0 ;$i--){if($l[$i]<$tl){$t=a($i,'').$h[$i].'</a> &gt; '.$t;$tl--;}if($tl<2)break;}}if($s==$hc[0])return $h[$s];else if($s>0)return a($hc[0],'').eregi_replace('category_', '', $h[$hc[0]]).'</a> &gt; '.$t.$h[$s];else if($f!='')return ucfirst($f);else return '&nbsp;';}
//__________________________________________________________________________
//
// ( 8 ) xnewsbox: extends the normal CMSimple Newsbox. Provides the possibility to show individual Newsboxes at differetn pages.///

//function xnewsbox(){global $news;if($news==""){echo newsbox("News");}else{echo newsbox($news);}}

?>